# Vamos a encontrar x en la función
# f(x) = (x − 2)(x − 5) + sen(1.5πx)
# que la minimice
# 
# f(x) = x^2 - 7x + 10 + sen(1.5πx)
# Tenemos que resolver la derivada de f(x)
# f'(x) = 2x - 7 + 1.5 pi cos(1.5πx) 
import math
import sys

n = len( sys.argv )
if n != 2 :
	print("Args: valor_inicial")
	sys.exit(1)

a = float( sys.argv[1] )

i = 0
while i < 20 :
	x = a
	f = 2*x - 7 + 1.5*math.pi*math.cos(1.5*math.pi*x)
	fp = 2 - 1.5*math.pi*1.5*math.pi * math.sin( 1.5*math.pi*x)

	Da = -f/fp
	if math.fabs(Da) < 1e-10 : 
		break

	a += Da
	x = a
	f =  x*x - 7*x + 10 + math.sin(1.5*math.pi*x)

	print( i, a, f )

	i += 1
